/*
 * Esta clase sirve para generar de forma aleatoria las 7 cartas en la mesa
 * */

package com.roshka.bootcamp004.mano;

public class Mano {
Carta[] mano;
	
	public Mano() {
		this.obtenerMano();
	}
	
	private void obtenerMano() {
		//Creamos un lugar donde cargar las cartas
		this.mano = new Carta[7];
		//Generamos las combinaciones de cartas
		for(int i = 0;i<7;i++) {
			mano[i] = new Carta();
		}
		//Comprobamos que no se existe cartas iguales
		this.verificarManoCartasNoIguales();
	}
	
	private void verificarManoCartasNoIguales() {
		for(int i = 0;i<6;i++) {
			for(int j = i + 1;j<7;j++) {
				if(this.mano[i].obtenerCarta().compareTo(this.mano[j].obtenerCarta())==0) {
					this.mano = null;
					this.obtenerMano();
				}
			}
		}
	}
	
	/**
	 * Entrega una mano de carta
	 * @return La mano en formato cadena
	 */
	public String aCadena() {
		String resultado = "";
		for(int i = 0;i<7;i++) {
			resultado = resultado + mano[i].obtenerCarta() + " ";
		}
		return resultado;
	}
	
	/**
	 * Entrega una mano de carta
	 * @return Array de objeto tipo 'Carta'
	 */
	public Carta[] aArrayTipoCarta() {
		return this.mano;
	}

}
