import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.nio.charset.Charset;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.*;
import com.roshka.bootcamp004.mano.Carta;
import com.roshka.bootcamp004.poker.*;

/**
 * Servlet implementation class mano_doc
 */
@WebServlet("/mano_doc")
public class mano_doc extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public mano_doc() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		//Aqui es donde obtenemos las barajas
		String archivoJSONBaraja = this.callURL("https://deckofcardsapi.com/api/deck/new/shuffle/?deck_count=1");
		//Obtenemos el id de la baraja
		String id_baraja = (new JSONObject(archivoJSONBaraja)).getString("deck_id");
		String direccionCartas = "https://deckofcardsapi.com/api/deck/"+id_baraja+"/draw/?count=5";
		//Obtenemos el json de las barajas
		String JSON5Cartas = this.callURL(direccionCartas);
		//Ahora tenemos que separar las barajas,puesto que cada baraja es un JSON
		JSONArray lista_json_cartas = (new JSONObject(JSON5Cartas)).getJSONArray("cards");
		//Ahora vamos a cargar los valores
		String[] valoresCartas = new String[lista_json_cartas.length()];
		for(int i=0;i<valoresCartas.length;i++) {
			valoresCartas[i] = lista_json_cartas.getJSONObject(i).getString("code");
		}
		//Una vez que cargamos los valores, vamos a crear la lista de cartas
		Carta[] cartas = new Carta[5];
		for(int i=0;i<valoresCartas.length;i++) {
			if(valoresCartas[i].charAt(0)=='0') {
				cartas[i] = new Carta("T"+valoresCartas[i].charAt(1));
			}else {
				cartas[i] = new Carta(valoresCartas[i]);
			}
		}
		//Una vez que tenes las manos, obtenemos el resultado
		Poker obtenerJugada = new Poker();
		String resultadoMano = obtenerJugada.mejorJugada(cartas);
		//Ordenamos las cartas de menor a mayor
		cartas = obtenerJugada.ordenarCartasValor(cartas);
		//Ahora vamos a cargar las urls de las direcciones de las barajas
		String[] direcciones_url = new String[lista_json_cartas.length()];
		for(int i=0;i<direcciones_url.length;i++) {
			for(int j=0;j<lista_json_cartas.length();j++) {
				if(cartas[i].obtenerCarta().charAt(0)=='T') {
					String temp = "0"+cartas[i].obtenerCarta().charAt(1);
					if(temp.compareTo(lista_json_cartas.getJSONObject(j).getString("code"))==0) {
						direcciones_url[i]=lista_json_cartas.getJSONObject(j).getString("image");
						break;
					}
				}else {
					if(cartas[i].obtenerCarta().compareTo(lista_json_cartas.getJSONObject(j).getString("code"))==0) {
						direcciones_url[i]=lista_json_cartas.getJSONObject(j).getString("image");
						break;
					}
				}
			}
		}
		//Convertimos la lista de cargas en String
		String manosCartas = new String();
		for(int i=0;i<cartas.length;i++) {
			manosCartas = manosCartas+cartas[i].obtenerCarta()+" ";
		}
		System.out.println("Cartas ordenados: "+manosCartas);
		//Preparamos el request para enviar al jsp
		request.setAttribute("imagenesCarta", direcciones_url);
		request.setAttribute("resultadoMano", resultadoMano);
		//Una vez obtenidos los valores, enviar al jsp
		RequestDispatcher rd = getServletContext().getRequestDispatcher("/WEB-INF/views/resultadoManoDoc.jsp");
		rd.forward(request, response);
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		doGet(request, response);
	}
	
	public String callURL(String myURL) {
		System.setProperty("http.agent", "Chrome");//Esto es lo que permite que funcione, sino da un error 403
		System.out.println("Requeted URL:" + myURL);
		StringBuilder sb = new StringBuilder();
		URLConnection urlConn = null;
		InputStreamReader in = null;
		try {
			URL url = new URL(myURL);
			urlConn = url.openConnection();
			if (urlConn != null)
				urlConn.setReadTimeout(60 * 1000);
			if (urlConn != null && urlConn.getInputStream() != null) {
				in = new InputStreamReader(urlConn.getInputStream(),
						Charset.defaultCharset());
				BufferedReader bufferedReader = new BufferedReader(in);
				if (bufferedReader != null) {
					int cp;
					while ((cp = bufferedReader.read()) != -1) {
						sb.append((char) cp);
					}
					bufferedReader.close();
				}
			}
		in.close();
		} catch (Exception e) {
			throw new RuntimeException("Exception while calling URL:"+ myURL, e);
		} 
 
		return sb.toString();
	}
}
