package mejorCombinacion;

import java.util.ArrayList;
import com.roshka.bootcamp004.mano.*;
import com.roshka.bootcamp004.poker.*;

public class MejoresCombinaciones {
	int[] jugadas;//Carga los tipos de manos
	int mejorJugada;//Carga el mejor tipo de mano
	Carta[][] combinaciones;//Donde se almacenan todas las manos
	ArrayList<Carta[]> mejoresJugadas;
	Combinaciones combinacionesGen;
	
	public MejoresCombinaciones() {
		this.combinacionesGen = new Combinaciones();
		this.combinaciones = combinacionesGen.obtenerCombinaciones();
		this.mejorJugada = 8;
		this.mejoresJugadas = new ArrayList<>();
	}
	
	public Combinaciones obtenerCombinacionGen() {
		return this.combinacionesGen;
	}
	
	//Establecemos quien es el ganador
	public Carta[] ganador() {
		Carta[] resultado = null;
		//Primero vamos a clasificar las combinaciones
		this.clasificarJugadas();
		//Despues establece cual es la mejor jugada
		this.mejorJugada();
		//Cargamos en un array las mejores jugadas
		for(int i=0;i<this.jugadas.length;i++){
			if(this.jugadas[i] == this.mejorJugada) {
				this.mejoresJugadas.add(this.combinaciones[i]);
			}
		}
		//obtenemos la mejor jugada
		if(this.mejoresJugadas.size()==1) {
			System.out.println("Mejor Jugada: "+this.mejoresJugadas.get(0));
			resultado = this.mejoresJugadas.get(0);
		}else {
			System.out.println("Mejor Jugada: "+(new Poker()).jugadas[this.mejorJugada]);
			//Clasificamos cual de las mejores jugadas, es la mejor jugada
			resultado = (new SelectorGanador(this.mejoresJugadas,this.mejorJugada)).procesar();
		}
		return resultado;
	}
	
	//Crea la lista de tipos de jugadas
	private void clasificarJugadas() {
		this.jugadas = new int[this.combinaciones.length];
		ClasificadorMano clasifica = new ClasificadorMano();
		for(int i=0;i<this.jugadas.length;i++) {
			this.jugadas[i] = clasifica.mejorJugadaNumero(combinaciones[i]);
		}
	}
	
	//Halla la mejor jugada
	private void mejorJugada() {
		for(int i = 0;i<jugadas.length;i++) {
			if(this.mejorJugada>jugadas[i]) {
				this.mejorJugada = jugadas[i];
			}
		}
	}
}
