package mejorCombinacion;

import java.util.ArrayList;
import com.roshka.bootcamp004.mano.*;

public class SelectorGanador {
	ArrayList<Carta[]> lista_p_ganadores;
	int mejor;
	
	public SelectorGanador(ArrayList<Carta[]> entrada,int mejorTipo){
		this.lista_p_ganadores = entrada;
		this.mejor = mejorTipo;
	}
	
	public Carta[] procesar() {
		ArrayList<Carta[]> respuesta = null;
		//Cada jugada tiene un proceso diferente 
		if(this.mejor==1) {
			respuesta = this.casoPoker();
		}else if(this.mejor==2) {
			respuesta = this.casoFull();
		}else if(this.mejor == 3) {
			respuesta = this.casoColorYCartaAlta();
		}else if(this.mejor == 4) {
			respuesta = this.casoEscalera();
		}else if(this.mejor == 5) {
			respuesta = this.casoTrio();
		}else if(this.mejor == 6) {
			respuesta = this.casoParDoble();
		}else if(this.mejor == 7) {
			respuesta = this.casoPar();
		}else if(this.mejor == 8){
			respuesta = this.casoColorYCartaAlta();
		}
		//Retorna el mazo ganador
		return respuesta.get(0);
		
	}
	
	private ArrayList<Carta[]> casoPar() {
		ArrayList<Carta[]> temporal = this.lista_p_ganadores;
		int pos_mejor;
		ClsOrdena compara = new ClsOrdena();
		for(int i = 0;i<temporal.size()-1;i++) {
			Carta[] mejorTemp = temporal.get(i);
			pos_mejor = i;
			for(int j = i+1;j<temporal.size();j++) {
				/*
				 * Existen tres casos
				 * 1- Cuando hay doble A
				 * 2- Cuando hay una A
				 * 3- Cuando no hay A
				 */
				//Caso uno
				if(mejorTemp[0].obtenerCarta().charAt(0) == 'A' && 
						mejorTemp[1].obtenerCarta().charAt(0) == 'A') {
					if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A' && 
						temporal.get(j)[1].obtenerCarta().charAt(0) == 'A') {
						for(int k = 2;k<mejorTemp.length;k++) {
							if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
									temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
								mejorTemp = temporal.get(j);
								pos_mejor = j;
								break;
							}
						}
					}else {
						break;
					}
				}else if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A' && 
						temporal.get(j)[1].obtenerCarta().charAt(0) == 'A') {
					mejorTemp = temporal.get(j);
					pos_mejor = j;
				//Caso dos 
				}else if(mejorTemp[0].obtenerCarta().charAt(0) == 'A') {
					//Aqui puede ocurrir que la otra mano tenga tambien una A
					if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A') {
						for(int k = 1;k<mejorTemp.length;k++) {
							if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
									temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
								mejorTemp = temporal.get(j);
								pos_mejor = j;
								break;
							}
						}
					}else {
						for(int k = 1;k<mejorTemp.length-1;k++) {
							if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
									temporal.get(j)[k-1].obtenerCarta().charAt(0)) == -1) {
								mejorTemp = temporal.get(j);
								pos_mejor = j;
								break;
							}
						}
					}
				}else if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A') {
					for(int k = 1;k<mejorTemp.length-1;k++) {
						if(compara.compararValor(mejorTemp[k-1].obtenerCarta().charAt(0), 
								temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
							mejorTemp = temporal.get(j);
							pos_mejor = j;
							break;
						}
					}
				//Tercer caso
				}else {
					for(int k = 0;k<mejorTemp.length-1;k++) {
						if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
								temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
							mejorTemp = temporal.get(j);
							pos_mejor = j;
							break;
						}
					}
				}
			}
			//Realizamos el intercambio
			if(pos_mejor != i) {
				Carta[] aux = temporal.get(pos_mejor);
				temporal.set(pos_mejor, temporal.get(i));
				temporal.set(i, aux);
			}
		}
		return temporal;
	}

	private ArrayList<Carta[]> casoParDoble() {
		ArrayList<Carta[]> temporal = this.lista_p_ganadores;
		int pos_mejor;
		ClsOrdena compara = new ClsOrdena();
		for(int i = 0;i<temporal.size()-1;i++) {
			Carta[] mejorTemp = temporal.get(i);
			pos_mejor = i;
			for(int j = i+1;j<temporal.size();j++) {
				/*Existen tres casos
					1-Cuando hay un par de ases
					2-Cuando hay un A
				3-Cuando no hay A*/
				//Primer caso
				if(mejorTemp[0].obtenerCarta().charAt(0) == 'A' && 
						mejorTemp[1].obtenerCarta().charAt(0) == 'A') {
					//Aqui puede ocurrir que tambien la otra mano tenga un doble A
					if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A' && 
							temporal.get(j)[1].obtenerCarta().charAt(0) == 'A') {
						//Realizamos la comparacion carta por carta
						for(int k = 2;k<mejorTemp.length;k++) {
							if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
									temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
								mejorTemp = temporal.get(j);
								pos_mejor = j;
								break;
							}
						}
					}else {
						break;
					}
				}else if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A' && 
						temporal.get(j)[1].obtenerCarta().charAt(0) == 'A') {
					mejorTemp = temporal.get(j);
					pos_mejor = j;
				//Caso dos
				}else if(mejorTemp[0].obtenerCarta().charAt(0) == 'A') {
					//Aqui puede ocurrir que la otra mano tenga tambien una A
					if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A') {
						for(int k = 1;k<mejorTemp.length;k++) {
							if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
									temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
								mejorTemp = temporal.get(j);
								pos_mejor = j;
								break;
							}
						}
					}else {
						for(int k = 1;k<mejorTemp.length-1;k++) {
							if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
									temporal.get(j)[k-1].obtenerCarta().charAt(0)) == -1) {
								mejorTemp = temporal.get(j);
								pos_mejor = j;
								break;
							}
						}
					}
				}else if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A') {
					//Aqui estoy ahora 
					for(int k = 1;k<mejorTemp.length-1;k++) {
						if(compara.compararValor(mejorTemp[k-1].obtenerCarta().charAt(0), 
								temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
							mejorTemp = temporal.get(j);
							pos_mejor = j;
							break;
						}
					}
				//Tercer caso
				}else {
					for(int k = 0;k<mejorTemp.length-1;k++) {
						if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
								temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
							mejorTemp = temporal.get(j);
							pos_mejor = j;
							break;
						}
					}
				}
			}
			//Realizamos el intercambio
			if(pos_mejor != i) {
				Carta[] aux = temporal.get(pos_mejor);
				temporal.set(pos_mejor, temporal.get(i));
				temporal.set(i, aux);
			}
		}
		return temporal;
	}
	
	//Esto se analiza mas tarde
	private ArrayList<Carta[]> casoEscalera() {
		ArrayList<Carta[]> temporal = this.lista_p_ganadores;
		int pos_mejor;
		ClsOrdena compara = new ClsOrdena();
		/* Existen 
		 * 1- Cuando es una escalera real (esta es la mejor mano)
		 * 2- Cuando tienes una escalera A 2 3 4 5 (es la peor escalera)
		 * 3- Cualquier otra escalera
		 * */
		for(int i = 0;i<temporal.size()-1;i++) {
			Carta[] mejorTemp = temporal.get(i);
			pos_mejor = i;
			for(int j = i+1;j<temporal.size();j++) {
				//Caso 1 (esta es la mejor mano)
				if(mejorTemp[0].obtenerCarta().charAt(0) == 'A' && mejorTemp[1].obtenerCarta().charAt(0)=='T'){
					break;
				}else if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A' && mejorTemp[1].obtenerCarta().charAt(0)=='T'){
					mejorTemp = temporal.get(j);
					pos_mejor = j;
					break;
				}
				//Caso 2 (esta es la peor escalera)
				if(mejorTemp[0].obtenerCarta().charAt(0) == 'A') {
					mejorTemp = temporal.get(j);
					pos_mejor = j;
				}else if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A'){
					continue;
				//Caso 3: Cualquier otra escalera
				}else {
					for(int k = 0;k<mejorTemp.length;k++) {
						if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
								temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
							mejorTemp = temporal.get(j);
							pos_mejor = j;
							break;
						}
					}
				}
			}
			//Realizamos el intercambio
			if(pos_mejor != i) {
				Carta[] aux = temporal.get(pos_mejor);
				temporal.set(pos_mejor, temporal.get(i));
				temporal.set(i, aux);
			}
		}
		return temporal;
	}

	private ArrayList<Carta[]> casoTrio() {
		ArrayList<Carta[]> temporal = this.lista_p_ganadores;
		//Va a ver tres casos
		//1-Cuando tiene un trio con A
		//2-Cuando tiene una A
		//3-Cuando no tiene A
		int pos_mejor;
		ClsOrdena compara = new ClsOrdena();
		//Ahora vamos a ordenar la lista de la mejor a la peor jugada
		for(int i = 0; i<temporal.size()-1;i++) {
			//Tomamos una mano
			Carta[] mejorTemp = temporal.get(i);
			pos_mejor = i;
			//Y aqui tomamos la otra mano para comparar
			for(int j = i+1;j<temporal.size();j++) {
				 //1-Cuando tiene un trio de A (no existe una mejor baraja de trio que esta)
				if(mejorTemp[0].obtenerCarta().charAt(0) == 'A' && 
						mejorTemp[1].obtenerCarta().charAt(0) == 'A' && 
							mejorTemp[2].obtenerCarta().charAt(0) == 'A') {
					if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A' && 
							temporal.get(j)[1].obtenerCarta().charAt(0) == 'A' && 
								temporal.get(j)[2].obtenerCarta().charAt(0) == 'A') {
						for(int k = 3;k<mejorTemp.length;k++) {
							if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
									temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
								mejorTemp = temporal.get(j);
								pos_mejor = j;
								break;
							}
						}
					}else {
						break;
					}
				}else if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A' && 
							temporal.get(j)[1].obtenerCarta().charAt(0) == 'A' && 
								temporal.get(j)[2].obtenerCarta().charAt(0) == 'A') {
					mejorTemp = temporal.get(j);
					pos_mejor = j;
				//2-Cuando se tiene una A
				}else if(mejorTemp[0].obtenerCarta().charAt(0) == 'A') {
					//Si los dos tienen al comienzo el A
					if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A') {
						Carta mano1 = mejorTemp[1];
						Carta mano2 = temporal.get(j)[1];
						if(compara.compararValor(mano1.obtenerCarta().charAt(0),mano2.obtenerCarta().charAt(0))==-1) {
							mejorTemp = temporal.get(j);
							pos_mejor = j;
						}
					}else {
						Carta mano11 = mejorTemp[1];
						Carta mano21 = temporal.get(j)[1];
						if(compara.compararValor(mano11.obtenerCarta().charAt(0),mano21.obtenerCarta().charAt(0))==0) {
							break;
						}else if(compara.compararValor(mano11.obtenerCarta().charAt(0),mano21.obtenerCarta().charAt(0))==-1){
							mejorTemp = temporal.get(j);
							pos_mejor = j;
						}
					}	
				}else if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A') {
					Carta mano12 = mejorTemp[1];
					Carta mano22 = temporal.get(j)[1];
					if(compara.compararValor(mano12.obtenerCarta().charAt(0),mano22.obtenerCarta().charAt(0))==0) {
						mejorTemp = temporal.get(j);
						pos_mejor = j;
					}else if(compara.compararValor(mano12.obtenerCarta().charAt(0),mano22.obtenerCarta().charAt(0))==-1){
						mejorTemp = temporal.get(j);
						pos_mejor = j;
					}
				//3- Cuando no tiene A
				}else {
					for(int k = 0;k<mejorTemp.length;k++) {
						if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
								temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
							mejorTemp = temporal.get(j);
							pos_mejor = j;
							break;
						}
					}
				}
			}
			//Realizamos el intercambio
			if(pos_mejor != i) {
				Carta[] aux = temporal.get(pos_mejor);
				temporal.set(pos_mejor, temporal.get(i));
				temporal.set(i, aux);
			}
		}
		//Retornamos la lista ordenada
		return temporal;
		
	}

	private ArrayList<Carta[]> casoColorYCartaAlta() {
		ArrayList<Carta[]> temporal = this.lista_p_ganadores;
		int pos_mejor;
		ClsOrdena compara = new ClsOrdena();
		for(int i = 0;i<temporal.size()-1;i++) {
			Carta[] mejorTemp = temporal.get(i);
			pos_mejor = i;
			for(int j = i+1;j<temporal.size();j++) {
				//Que pasa si la primera mano contiene una A
				if(mejorTemp[0].obtenerCarta().charAt(0) == 'A') {
					//Que pasa si la otra mano tambien tiene una A
					if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A') {
						//Se realiza la comparacion con las siguientes cartas
						for(int k = 1;k<mejorTemp.length;k++) {
							if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
									temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
								mejorTemp = temporal.get(j);
								pos_mejor = j;
								break;
							}
						}
					}else {
						break;
					}
				}else if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A') {
					mejorTemp = temporal.get(j);
					pos_mejor = j;
				}else {
					for(int k = 0;k<mejorTemp.length;k++) {
						if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
								temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
							mejorTemp = temporal.get(j);
							pos_mejor = j;
							break;
						}
					}
				}
			}
			//Realizamos el intercambio
			if(pos_mejor != i) {
				Carta[] aux = temporal.get(pos_mejor);
				temporal.set(pos_mejor, temporal.get(i));
				temporal.set(i, aux);
			}
		}
		return temporal;
	}

	private ArrayList<Carta[]> casoFull() {
		ArrayList<Carta[]> temporal = this.lista_p_ganadores;
		//Va a ver tres casos
		//1-Cuando tiene un trio con A
		//2-Cuando tiene un par de A
		//3-Cuando no tiene A
		int pos_mejor;
		ClsOrdena compara = new ClsOrdena();
		//Ahora vamos a ordenar la lista de la mejor a la peor jugada
		for(int i = 0; i<temporal.size()-1;i++) {
			//Tomamos una mano
			Carta[] mejorTemp = temporal.get(i);
			pos_mejor = i;
			//Y aqui tomamos la otra mano para comparar
			for(int j = i+1;j<temporal.size();j++) {
				 //1-Cuando tiene un trio de A (no existe una mejor baraja de trio que esta)
				if(mejorTemp[0].obtenerCarta().charAt(0) == 'A' && 
						mejorTemp[1].obtenerCarta().charAt(0) == 'A' && 
							mejorTemp[2].obtenerCarta().charAt(0) == 'A') {
					if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A' && 
							temporal.get(j)[1].obtenerCarta().charAt(0) == 'A' && 
								temporal.get(j)[2].obtenerCarta().charAt(0) == 'A') {
						for(int k = 3;k<mejorTemp.length;k++) {
							if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
									temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
								mejorTemp = temporal.get(j);
								pos_mejor = j;
								break;
							}
						}
					}else {
						break;
					}
				}else if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A' && 
							temporal.get(j)[1].obtenerCarta().charAt(0) == 'A' && 
								temporal.get(j)[2].obtenerCarta().charAt(0) == 'A') {
					mejorTemp = temporal.get(j);
					pos_mejor = j;
					break;
				//2-Cuando se tiene un par de  A
						//Si la primera mano comienza con el par de  A
				}else if(mejorTemp[0].obtenerCarta().charAt(0) == 'A' && 
							mejorTemp[1].obtenerCarta().charAt(0) == 'A') {
					//Si los dos tienen al comienzo el par de A
					if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A' && 
							temporal.get(j)[1].obtenerCarta().charAt(0) == 'A') {
						Carta mano1 = mejorTemp[2];
						Carta mano2 = temporal.get(j)[2];
						if(compara.compararValor(mano1.obtenerCarta().charAt(0),mano2.obtenerCarta().charAt(0))==-1) {
							mejorTemp = temporal.get(j);
							pos_mejor = j;
						}
					//Caso contrario
					}else {
						Carta mano11 = mejorTemp[2];
						Carta mano21 = temporal.get(j)[2];
						if(compara.compararValor(mano11.obtenerCarta().charAt(0),mano21.obtenerCarta().charAt(0))==0) {
							continue;//Primer posible problema: brake o continue?
						}else if(compara.compararValor(mano11.obtenerCarta().charAt(0),mano21.obtenerCarta().charAt(0))==-1){
							mejorTemp = temporal.get(j);
							pos_mejor = j;
						}
					}	
				}else if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A' && 
							temporal.get(j)[1].obtenerCarta().charAt(0) == 'A') {
					Carta mano12 = mejorTemp[2];
					Carta mano22 = temporal.get(j)[2];
					if(compara.compararValor(mano12.obtenerCarta().charAt(0),mano22.obtenerCarta().charAt(0))==0) {
						mejorTemp = temporal.get(j);
						pos_mejor = j;
					}else if(compara.compararValor(mano12.obtenerCarta().charAt(0),mano22.obtenerCarta().charAt(0))==-1){
						mejorTemp = temporal.get(j);
						pos_mejor = j;
					}
				//3- Cuando no tiene A
				}else {
					for(int k = 0;k<mejorTemp.length;k++) {
						if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
								temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
							mejorTemp = temporal.get(j);
							pos_mejor = j;
							break;
						}
					}
				}
			}
			//Realizamos el intercambio
			if(pos_mejor != i) {
				Carta[] aux = temporal.get(pos_mejor);
				temporal.set(pos_mejor, temporal.get(i));
				temporal.set(i, aux);
			}
		}
		//Retornamos la lista ordenada
		return temporal;
		
	}

	private ArrayList<Carta[]> casoPoker() {
		ArrayList<Carta[]> temporal = this.lista_p_ganadores;
		//Va a ver tres casos
		//1-Cuando tiene un poker con A
		//2-Cuando tiene una A
		//3-Cuando no tiene A
		int pos_mejor;
		ClsOrdena compara = new ClsOrdena();
		//Ahora vamos a ordenar la lista de la mejor a la peor jugada
		for(int i = 0; i<temporal.size()-1;i++) {
			//Tomamos una mano
			Carta[] mejorTemp = temporal.get(i);
			pos_mejor = i;
			//Y aqui tomamos la otra mano para comparar
			for(int j = i+1;j<temporal.size();j++) {
				 //1-Cuando tiene un poker de A (no existe una mejor baraja de poker que esta)
				if(mejorTemp[0].obtenerCarta().charAt(0) == 'A' && 
						mejorTemp[1].obtenerCarta().charAt(0) == 'A' &&
							mejorTemp[2].obtenerCarta().charAt(0) == 'A' &&
								mejorTemp[3].obtenerCarta().charAt(0) == 'A') {
					if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A' && 
						temporal.get(j)[1].obtenerCarta().charAt(0) == 'A' &&
							temporal.get(j)[2].obtenerCarta().charAt(0) == 'A' &&
								temporal.get(j)[3].obtenerCarta().charAt(0) == 'A') {
						//Solo comparamos la ultima carta
						if(compara.compararValor(mejorTemp[4].obtenerCarta().charAt(0), 
								temporal.get(j)[4].obtenerCarta().charAt(0)) == -1) {
							mejorTemp = temporal.get(j);
							pos_mejor = j;
						}
					}else {
						break;
					}
				}else if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A' && 
						temporal.get(j)[1].obtenerCarta().charAt(0) == 'A') {
					mejorTemp = temporal.get(j);
					pos_mejor = j;
					//2-Cuando se tiene una A
						//Si los dos tienen al comienzo la A
							//Si la primera mano comienza con A
				}else if(mejorTemp[0].obtenerCarta().charAt(0) == 'A') {
					if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A') {
						Carta mano1 = mejorTemp[1];
						Carta mano2 = temporal.get(j)[1];
						if(compara.compararValor(mano1.obtenerCarta().charAt(0),mano2.obtenerCarta().charAt(0))==-1) {
							mejorTemp = temporal.get(j);
							pos_mejor = j;
						}
					}else {
						Carta mano11 = mejorTemp[1];
						Carta mano21 = temporal.get(j)[0];
						if(compara.compararValor(mano11.obtenerCarta().charAt(0),mano21.obtenerCarta().charAt(0))==0) {
							continue;//Primer posible problema: brake o continue?
						}else if(compara.compararValor(mano11.obtenerCarta().charAt(0),mano21.obtenerCarta().charAt(0))==-1){
							mejorTemp = temporal.get(j);
							pos_mejor = j;
						}
					}	
				}else if(temporal.get(j)[0].obtenerCarta().charAt(0) == 'A') {
					Carta mano12 = mejorTemp[0];
					Carta mano22 = temporal.get(j)[1];
					if(compara.compararValor(mano12.obtenerCarta().charAt(0),mano22.obtenerCarta().charAt(0))==0) {
						mejorTemp = temporal.get(j);
						pos_mejor = j;
					}else if(compara.compararValor(mano12.obtenerCarta().charAt(0),mano22.obtenerCarta().charAt(0))==-1){
						mejorTemp = temporal.get(j);
						pos_mejor = j;
					}
				//3- Cuando no tiene A
				}else {
					for(int k = 0;k<mejorTemp.length;k++) {
						if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
								temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
							mejorTemp = temporal.get(j);
							pos_mejor = j;
							break;
						}
					}
				}
			}
			//Realizamos el intercambio
			if(pos_mejor != i) {
				Carta[] aux = temporal.get(pos_mejor);
				temporal.set(pos_mejor, temporal.get(i));
				temporal.set(i, aux);
			}
		}
		//Retornamos la lista ordenada
		return temporal;
	}

	
	
	public ArrayList<Carta[]> primerGrupo() {
		//Almacenamos la lista 
		ArrayList<Carta[]> temporal = this.lista_p_ganadores;
		int pos_mejor;
		ClsOrdena compara = new ClsOrdena();
		//Ahora vamos a ordenar la lista de la mejor a la peor jugada
		for(int i = 0; i<temporal.size()-1;i++) {
			Carta[] mejorTemp = temporal.get(i);
			pos_mejor = i;
			for(int j = i+1;j<this.lista_p_ganadores.size();j++) {
				for(int k = 0;k<mejorTemp.length;k++) {
					if(compara.compararValor(mejorTemp[k].obtenerCarta().charAt(0), 
							temporal.get(j)[k].obtenerCarta().charAt(0)) == -1) {
						mejorTemp = temporal.get(j);
						pos_mejor = j;
						break;
					}
				}
			}
			//Realizamos el intercambio
			if(pos_mejor != i) {
				Carta[] aux = temporal.get(pos_mejor);
				temporal.set(pos_mejor, temporal.get(i));
				temporal.set(i, aux);
			}
		}
		//Retornamos la lista ordenada
		return temporal;
	}
	

}
